unit hiSecondsCounter;

interface

uses Kol,Share,Debug;

type
  THISecondsCounter = class(TDebug)
   private
    FStr:string;
    FCount,Fh,Fm,Fs:integer;
    
    FTimer:PTimer;
    procedure SetEnable(Value:boolean);
    procedure OnTimer(Obj:PObj);
   public
    _event_onString:THI_Event;
    _event_onCount:THI_Event;
    _event_onTimer:THI_Event;
    _event_onStop:THI_Event;
    _data_Pos:THI_Event;
    _prop_Format:string;
    
    constructor Create;
    destructor Destroy; override;
    procedure _work_doTimer(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doPos(var _Data:TData; Index:word);
    procedure _var_Hour(var _Data:TData; Index:word);
    procedure _var_Min(var _Data:TData; Index:word);
    procedure _var_Sec(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_String(var _Data:TData; Index:word);
    property  _prop_Enable:boolean write SetEnable;

 end;

implementation

constructor THISecondsCounter.Create;
begin
   inherited Create;
   FTimer := NewTimer(1000);
   FTimer.Enabled := false;
   FTimer.OnTimer := onTimer;
end;

destructor THISecondsCounter.Destroy;
begin
   FTimer.Free;
   inherited Destroy;
end;

procedure THISecondsCounter._work_doTimer;
begin
   FTimer.Enabled := true;
end;

procedure THISecondsCounter._work_doStop;
begin
    FTimer.Enabled := false;
   _hi_OnEvent(_event_onStop);
end;

procedure THISecondsCounter.SetEnable;
begin
   FTimer.Enabled := Value;
end;

function FormatString(var x,y,z:integer; s:string):string;
var hh:string;
var mm:string;
var ss:string;
begin
     if z<10 then
          ss := '0' + int2str(z) else
          ss := int2str(z);
     if y<10 then
          mm := '0' + int2str(y) else
          mm := int2str(y);
     hh := int2str(x);
     Replace(s,'s',ss);
     Replace(s,'m',mm);
     Replace(s,'h',hh);
     Result:=s;
end;

procedure THISecondsCounter.OnTimer;
var str,s:string;
begin
     Fs := Fs+1;
     if Fs>59 then
     begin
          Fs := 0;
          Fm := Fm+1;
          if Fm>59 then
          begin
               Fm :=0;
               Fh := Fh+1;
          end;
     end;
     s:=_prop_Format;
     str := FormatString(Fh,Fm,Fs,s);
     FStr := str;
     FCount := FCount+1;
     _hi_onEvent(_event_onString,FStr);
     _hi_onEvent(_event_onCount,FCount);
     _hi_OnEvent(_event_onTimer);
end;

procedure THISecondsCounter._work_doClear;
var s:string;
begin
     Fh := 0;
     Fm := 0;
     Fs := 0;
     FCount := 0;
     s:=_prop_Format;
     FStr := FormatString(Fh,Fm,Fs,s);
     _hi_onEvent(_event_onString,FStr);
end;

procedure THISecondsCounter._work_doPos;
var s,s1,ch:string;
var i,j,h,m:integer;
begin
     s:=ReadString(_Data,_data_Pos,'');
     if s='' then exit else
     j:=Length(s);
     h:=str2int(s);
     i:=Length(int2str(h));
     if j=i then exit else
     ch:=Copy(s,i+1,1);
     s1:=GetTok(s,ch[1]);
     j:=Length(s);     
     m:=str2int(s);
     if m<10 then i:=2 else
     i:=Length(int2str(m));
     if j=i then exit else
     ch:=Copy(s,i+1,1);
     s1:=GetTok(s,ch[1]);
     Fs:=str2int(s);
     Fh:=h;
     Fm:=m;
end;

procedure THISecondsCounter._var_Hour;
begin
   _Data.data_type:=data_int;
   _Data.idata:=Fh;
end;

procedure THISecondsCounter._var_Min;
begin
   _Data.data_type:=data_int;
   _Data.idata:=Fm;
end;
 
procedure THISecondsCounter._var_Sec;
begin
   _Data.data_type:=data_int;
   _Data.idata:=Fs;
end;

procedure THISecondsCounter._var_Count;
begin
   _Data.data_type:=data_int;
   _Data.idata:=FCount;
end;

procedure THISecondsCounter._var_String;
begin
   _Data.data_type:=data_str;
   _Data.sdata:=FStr; 
end;

end.
